about summary refs log tree commit diff
path: root/exman.in
diff options
context:
space:
mode:
Diffstat (limited to 'exman.in')
-rw-r--r--exman.in52
1 files changed, 52 insertions, 0 deletions
diff --git a/exman.in b/exman.in
new file mode 100644
index 0000000..7d4a9c8
--- /dev/null
+++ b/exman.in
@@ -0,0 +1,52 @@
+#!/bin/sh
+set -eu
+
+die() {
+	echo "$@" >&2
+	exit 1
+}
+
+system=${1:-}
+[ -n "${system}" ] || die 'What system do you want?'
+shift
+
+export MANPATH="%%EXMANDIR%%/${system}"
+[ -d "${MANPATH}" ] || die "No manuals for ${system}"
+
+export MANSECT
+for sect in "${MANPATH}"/man*/; do
+	sect=${sect%/}
+	sect=${sect##*/man}
+	MANSECT="${MANSECT:-}${MANSECT:+:}${sect}"
+done
+
+# macOS man(1) refuses to search in directories such as "man3p", so do it
+# manually here unless there are other flags passed.
+hack() {
+	case "${1:-}" in
+		(-*) exec man "$@";;
+		([0-9]*) MANSECT=$1; shift;;
+	esac
+	[ $# -gt 0 ] || die 'What manual page do you want?'
+	for page in "$@"; do
+		found=0
+		IFS=:
+		for sect in $MANSECT; do
+			path="${MANPATH}/man${sect}/${page}"
+			for ext in ".${sect}" ".${sect}.gz"; do
+				[ -f "${path}${ext}" ] || continue
+				man "${path}${ext}"
+				found=1
+				break
+			done
+			[ $found -eq 0 ] || break
+		done
+		[ $found -ne 0 ] || die "No manual entry for ${page}"
+	done
+}
+
+if [ "$(uname)" = 'Darwin' ]; then
+	hack "$@"
+else
+	exec man "$@"
+fi
ps"June McEnroe 2020-11-26Publish "Inability"June McEnroe I don't know, it's something. 2020-11-26Render content into atom feedJune McEnroe And fix some atom lints. 2020-11-26Update plan with different things I won't doJune McEnroe 2020-11-19Add "Come On Petunia"June McEnroe 2020-11-13Add x4 to LESSJune McEnroe 2020-11-04Remove modified sensitivity settingsJune McEnroe 2020-10-29Remove editJune McEnroe 2020-10-27Switch gr alias back to git rebaseJune McEnroe I always type out git reset and sometimes still expect gr to be rebase... Never got used to it I guess. 2020-10-27Allow cd host: to cd to same path over sshJune McEnroe 2020-10-27Use SendEnv for cd host:pathJune McEnroe Works properly for weird paths, etc. 2020-10-27Allow cd host:path over sshJune McEnroe Requires AcceptEnv SSH_CD in the remote sshd_config. 2020-10-07Use mandoc -T utf8 for text.June McEnroe Don't depend on LANG being set. 2020-09-20Add The Awakened KingdomJune McEnroe A cute extra novella. Finally finished this series. 2020-09-12Move /opt/local back, cheat port select to use system manJune McEnroe This is not really how you're supposed to use the select system, I don't think, since the mandoc package actually creates those files, but it does work. This lets me actually use the git installed by MacPorts. 2020-09-12Move /opt/local behind /usr againJune McEnroe The reason I did this with pkgsrc was because I actually don't want the man(1) from mandoc, since it won't follow MANSECT. Same applies to MacPorts. I wish I could disable its man(1) with a variant or whatever. 2020-09-12Enable toc in cgit renderings of man pagesJune McEnroe But keep it disabled for READMEs since they always use non-standard sections and the TOC is just distracting there, I think. Also add the style so its h1 is the same size as the ones inside sections... 2020-09-11Install mandoc on macOSJune McEnroe 2020-09-11Rewrite install script yet againJune McEnroe 2020-09-11Remove NetBSD from install scriptJune McEnroe I never use it. 2020-09-11Use MacPorts rather than pkgsrcJune McEnroe My system is probably such a mess now... 2020-09-11Add debian VM name to sshJune McEnroe 2020-09-11Add influencer tweetJune McEnroe 2020-09-10Add The Kingdom of GodsJune McEnroe Reading has really slowed down :( 2020-09-07Add SunglassesJune McEnroe An IRC find. 2020-09-06Add Between the BreathsJune McEnroe One of those good songs from a soundtrack of a film that probably isn't? The summary sounds a lot more interesting than the title implies, at least. 2020-09-04Open /dev/tty in nudgeJune McEnroe This makes it work even when it's run connected to a pipe, i.e. as the notify command of catgirl... 2020-09-04Add nudgeJune McEnroe 2020-09-03Build fbclock with -lzJune McEnroe I guess this got lost somewhere, long ago... 2020-08-29Add tweets from retweetsJune McEnroe